/*
 * the oa project.
 *
 * Sed - december 1999
 *
 * This is public domain.
 *
 * the event file
 */

#include "event.h"

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

int wait_event(int screen_descriptor, int sound_descriptor, int is_sound_ok)
{
  int res=0;
  fd_set r, w;

  FD_ZERO(&r);
  FD_ZERO(&w);

  FD_SET(screen_descriptor, &r);

  if (is_sound_ok)
    FD_SET(sound_descriptor, &w);

  if (select(FD_SETSIZE, &r, &w, (fd_set *)0, (struct timeval *)0)==-1)
    return 0;

  if (FD_ISSET(screen_descriptor, &r))
    res|=SCREEN_EVENT;

  if (is_sound_ok && FD_ISSET(sound_descriptor, &w))
    res|=SOUND_EVENT;

  return res;
}
