/* the oa project.
 *
 * Sed - december 1999
 *
 * This is public domain.
 *
 * the screen file
 */

#include "screen.h"

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "waves.h"
#include "card.h"
#include "wav.h"

void draw_raw_button(SCREEN *s, int ux, int uy, int dx, int dy, int up_down)
{
  XGCValues gcv;

  if (up_down==UP)
    gcv.foreground=s->col[LIGHTGREY];
  else
    gcv.foreground=s->col[DARKGREY];
  gcv.line_width=1;
  gcv.cap_style=CapRound;
  XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground | GCLineWidth | GCCapStyle, &gcv);

  XDrawLine(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), ux, uy, dx, uy);
  XDrawLine(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), ux, uy+1, dx-1, uy+1);
  XDrawLine(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), ux, uy, ux, dy);
  XDrawLine(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), ux+1, uy, ux+1, dy-1);

  if (up_down==UP)
    gcv.foreground=s->col[DARKGREY];
  else
    gcv.foreground=s->col[LIGHTGREY];
  gcv.line_width=1;
  gcv.cap_style=CapRound;
  XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground | GCLineWidth | GCCapStyle, &gcv);

  XDrawLine(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), ux+1, dy, dx, dy);
  XDrawLine(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), ux+2, dy-1, dx, dy-1);
  XDrawLine(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), dx, uy+1, dx, dy);
  XDrawLine(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), dx-1, uy+2, dx-1, dy);
}

void draw_dump_button(SCREEN *s)
{
  draw_raw_button(s, 745, 43, 755, 53, s->dwb);
}

void draw_message_button(SCREEN *s)
{
  draw_raw_button(s, (int)s->mode2, (int)s->mode3, (int)s->mode4, (int)s->mode5, (int)s->mode6);
}

void draw_message(SCREEN *s)
{
  char *z="ok";
  XGCValues gcv;
  
  gcv.foreground=s->col[BLACK];
  XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground, &gcv);

  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 550, 16*3+17+256-30,
	      (char *)s->mode1, strlen((char *)s->mode1));

  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), (int)s->mode2+20, (int)s->mode3+8+10, z, strlen(z));

  draw_message_button(s);
}

void clear_message(SCREEN *s)
{
  XGCValues gcv;
  
  gcv.foreground=s->col[GREY];
  XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground, &gcv);

  XFillRectangle(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)),
		 550, 16*3+17+256-30-20, strlen((char *)s->mode1)*6, 30);

  XFillRectangle(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)),
		 (int)s->mode2, (int)s->mode3, (int)s->mode4-(int)s->mode2+1, (int)s->mode5-(int)s->mode3+1);
}

int is_in_dump_wav_button(SCREEN *s)
{
  if (s->mx>=745 && s->mx<=755 && s->my>=43 && s->my<=53)
    return 1;
  return 0;
}

int is_in_message_button(SCREEN *s)
{
 if (s->mx>=(int)s->mode2 && s->mx<=(int)s->mode4 && s->my>=(int)s->mode3 && s->my<=(int)s->mode5)
    return 1;
  return 0;
}

void black_message(SCREEN *s)
{
  register char *m=s->black_message;
  XGCValues gcv;

  gcv.foreground=s->col[GREY];
  XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground, &gcv);

  XFillRectangle(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)),
		 550, 256+16*3+256, 13*6, 20);

  gcv.foreground=s->col[BLACK];
  XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground, &gcv);
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 550, 256+16*3+17+256, m, strlen(m));

  XFlush(s->d);
}

void clear_mouse_coordinates(SCREEN *s)
{
  XGCValues gcv;

  gcv.foreground=s->col[GREY];
  XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground, &gcv);

  XFillRectangle(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)),
		 550, 256+16*3, 15*6, 20);

  XFlush(s->d);
}

void print_mouse_coordinates(SCREEN *s)
{
  XGCValues gcv;
  char p[512]; /* Should be enough, huh ? Buffer overflow you think ? Think twice ! */

  clear_mouse_coordinates(s);

  gcv.foreground=s->col[BLACK];
  XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground, &gcv);

  sprintf(p, "%d : %d", s->mx, s->my);
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 550, 256+16*3+17, p, strlen(p));
  XFlush(s->d);
}

void mouse_aspect(SCREEN *s, int asp)
{
  XDefineCursor(s->d, s->mw, s->curs[asp]);
  XDefineCursor(s->d, s->wf1, s->curs[asp]);
  XDefineCursor(s->d, s->wf2, s->curs[asp]);
  XDefineCursor(s->d, s->pw, s->curs[asp]);
  XFlush(s->d);
}

/* return 1 if ok 0 if not */
int enter_playmode(SCREEN *s)
{
  /* None should get the good Cursor value */
  if (XGrabPointer(s->d, s->mw, False, PointerMotionMask|ButtonReleaseMask, GrabModeAsync, GrabModeAsync, s->pw, None, 0)) {
    close_sound();
    return 0;
  }

  return 1;
}

void leave_playmode(SCREEN *s)
{
  XUngrabPointer(s->d, 0);
}

void draw_button(SCREEN *s, int b, int up_down)
{
  int ux, uy, dx, dy;

  ux=s->buttons[b][0];
  uy=s->buttons[b][1];
  dx=s->buttons[b][2];
  dy=s->buttons[b][3];

  draw_raw_button(s, ux, uy, dx, dy, up_down);
}

void draw_wave(SCREEN *s, Window win, WAVE *w)
{
  XGCValues gcv;
  int i;
  int y1=get_sample_sin(w, 0), y2;

  XClearWindow(s->d, win);

  gcv.foreground=s->col[WHITE];
  gcv.line_width=1;
  gcv.cap_style=CapRound;
  XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground | GCLineWidth | GCCapStyle, &gcv);

  for (i=0; i<w->nb_control_points; i++)
    XFillRectangle(s->d, win, DefaultGC(s->d, DefaultScreen(s->d)),
		   w->control_points_x[i]-1, 128-w->control_points_y[i]/256-1, 3, 3);

  for (i=1; i<512; i++) {
    y2=get_sample_sin(w, i);
    XDrawLine(s->d, win, DefaultGC(s->d, DefaultScreen(s->d)), i-1, 128-y1/256, i, 128-y2/256);
    y1=y2;
  }

  XFlush(s->d);
}

/* return 0 if the mouse is not in the specified button 1 if yes */
int is_in_the_button(SCREEN *s, int b)
{
  if (s->mx>=s->buttons[b][0] && s->my>=s->buttons[b][1] && s->mx<=s->buttons[b][2] && s->my<=s->buttons[b][3])
    return 1;

  return 0;
}

/* return 0 if the mouse is not in a button - the number of the button otherwise */
int is_in_a_button(SCREEN *s)
{
  int i;

  for (i=0; i<7; i++)
    if (s->mx>=s->buttons[i][0] && s->my>=s->buttons[i][1] && s->mx<=s->buttons[i][2] && s->my<=s->buttons[i][3])
      return i+1;

  return 0;
}

void reset_wave(SCREEN *s, Window win, WAVE *w)
{
  int *a, *b;

  a=realloc(w->control_points_x, 2*sizeof(int));
  b=realloc(w->control_points_y, 2*sizeof(int));

  if (!a || !b) {
    fprintf(stderr, "screen.reset_wave error with realloc, no reset\n");
    return;
  }

  w->control_points_x=a;
  w->control_points_y=b;
  w->nb_control_points=2;

  w->control_points_x[0]=0;
  w->control_points_y[0]=0;
  w->control_points_x[1]=256;
  w->control_points_y[1]=0;

  draw_wave(s, win, w);
}

/* return -1 if end 0 if not */
int button_action(SCREEN *s, int b)
{
  switch (b) {
    case 0 : /* quit */
      return -1;
    case 1 : /* up load */
      if (!load_wave(s->a, s->t1)) {
	s->mode=MESSAGE_MODE;
	s->mode2=(void *)(550+200-20);
	s->mode3=(void *)(16*3+17+256+40-40);
	s->mode4=(void *)(550+200-20+20*2+6*2);
	s->mode5=(void *)(16*3+17+256+40-30+10+7);
	s->mode6=(void *)UP;
	s->mode7=(void *)0;
	s->mode1="error loading file";
	draw_message(s);
      } else
	draw_wave(s, s->wf1, s->a);
      break;
    case 2 : /* up save */
      s->mode=MESSAGE_MODE;
      s->mode2=(void *)(550+200-20);
      s->mode3=(void *)(16*3+17+256+40-40);
      s->mode4=(void *)(550+200-20+20*2+6*2);
      s->mode5=(void *)(16*3+17+256+40-30+10+7);
      s->mode6=(void *)UP;
      s->mode7=(void *)0;
      if (save_wave(s->a, s->t1)==1)
	s->mode1="file saved ok";
      else
	s->mode1="error saving file";
      draw_message(s);
      break;
    case 3 : /* up reset */
      reset_wave(s, s->wf1, s->a);
      break;
    case 4 : /* down load */
      if (!load_wave(s->o, s->t2)) {
	s->mode=MESSAGE_MODE;
	s->mode2=(void *)(550+200-20);
	s->mode3=(void *)(16*3+17+256+40-40);
	s->mode4=(void *)(550+200-20+20*2+6*2);
	s->mode5=(void *)(16*3+17+256+40-30+10+7);
	s->mode6=(void *)UP;
	s->mode7=(void *)0;
	s->mode1="error loading file";
	draw_message(s);
      } else
	draw_wave(s, s->wf2, s->o);
      break;
    case 5 : /* down save */
      s->mode=MESSAGE_MODE;
      s->mode2=(void *)(550+200-20);
      s->mode3=(void *)(16*3+17+256+40-40);
      s->mode4=(void *)(550+200-20+20*2+6*2);
      s->mode5=(void *)(16*3+17+256+40-30+10+7);
      s->mode6=(void *)UP;
      s->mode7=(void *)0;
      if (save_wave(s->o, s->t2)==1)
	s->mode1="file saved ok";
      else
	s->mode1="error saving file";
      draw_message(s);
      break;
    case 6 : /* down reset */
      reset_wave(s, s->wf2, s->o);
      break;
  }
  return 0;
}

void draw_text(SCREEN *s, Window w, char *t)
{
  int l=strlen(t);
  XGCValues gcv;

  gcv.foreground=s->col[BLACK];
  XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground, &gcv);

  XClearWindow(s->d, w);
  XDrawString(s->d, w, DefaultGC(s->d, DefaultScreen(s->d)), 2, 12, t, l);

  XDrawLine(s->d, w, DefaultGC(s->d, DefaultScreen(s->d)), l*6+2+1, 0, l*6+2+1, 20);
}

void draw_screen(SCREEN *s)
{
  XGCValues gcv;
  int i;

  int my_x=0, my_y=0;

  char *s1="On the wave form window : click left button to insert a control point";
  char *s2="move on a control point and click right button to delete it";
  char *s3="click left on it and move to deplace it";

  char *c1="Wave form 1";
  char *c2="Wave form 2";

  char *d="Click in the grid and move your mouse to play some sound";

  char *f="File name";
  char *l="load";
  char *S="save"; /* do you like this S variable ? Cool, nope ? What if I miswrite it s ? huh huh... */

  char *q="quit";
  char *r="reset";

  char *f1="central frequency (1-30000 Hz)";
  char *f2="number of octaves (0.0001-20.0)";

  char *w1="dump to wav :";
  char *w2=".wav";

  gcv.foreground=s->col[BLACK];
  XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground, &gcv);

  /* first, draw the texts */
  /* form window using explaination */
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 20, 14, s1, strlen(s1));
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 20+26*6, 30, s2, strlen(s2));
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 20+26*6, 46, s3, strlen(s3));

  /* form window titles */
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 20+10*6+20*6, 256+16*3+14, c1, strlen(c1));
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 20+10*6+20*6, 256+16*3+256+16+14, c2, strlen(c2));

  /* big window explaination */
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 20+10*4+50*6, 256+16*3+256+16+14+256+16, d, strlen(d));

  /* file name - load - save - reset - upper window */
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 10+512+20, 100, f, strlen(f));
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 10+512+20+40, 150, l, strlen(l));
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 10+512+20+40+100, 150, S, strlen(S));
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 10+512+20+40+100+100-3, 150, r, strlen(r));

  /* file name - load - save - reset - downer window */
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 10+512+20, 100+256+16, f, strlen(f));
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 10+512+20+40, 150+256+16, l, strlen(l));
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 10+512+20+40+100, 150+256+16, S, strlen(S));
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 10+512+20+40+100+100-3, 150+256+16, r, strlen(r));

  /* quit */
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 10+512+20+40+50, 50, q, strlen(q));

  /* frequencies stuff */
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 950-strlen(f1)*6-10, 256+16*3+256-20+14, f1, strlen(f1));
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 950-strlen(f2)*6-10, 256+16*3+256+14, f2, strlen(f2));

  /* the button around */
  for (i=0; i<7; i++)
    draw_button(s, i, UP);

  /* now, draw the wave forms */
  draw_wave(s, s->wf1, s->a);
  draw_wave(s, s->wf2, s->o);

  /* draw the file names */
  draw_text(s, s->tw1, s->t1);
  draw_text(s, s->tw2, s->t2);

  /* and frequency stuff */
  draw_text(s, s->cfw, s->cft);
  draw_text(s, s->now, s->not);

  /* dump to wav stuff */
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 750+100-strlen(w1)*6-10, 40+12, w1, strlen(w1));
  XDrawString(s->d, s->mw, DefaultGC(s->d, DefaultScreen(s->d)), 750+100+20*6+4, 40+12, w2, strlen(w2));
  draw_text(s, s->dww, s->dwt);
  draw_dump_button(s);

  black_message(s);

  /* mode dependant drawing */
  if (s->mode == MESSAGE_MODE)
    draw_message(s);

  /* beginning of our code (Christian Klein) */
  /* Felix and me decided that a grid will help people to navigate */

  gcv.foreground=s->col[DARKGREY];
  gcv.line_width=1;
  XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground | GCLineWidth, &gcv);


  /* 0, 16*3+256+16+256+16, 1024, 256 */

  /* draw the horizontal lines (every fourth line is coloured white) */
  while (my_x<1024)
  {
	my_x += 16;
	if (!(my_x%(16*4)))
	{
		gcv.foreground=s->col[WHITE];
		XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground | GCLineWidth, &gcv);
	}
	XDrawLine(s->d, s->pw, DefaultGC(s->d, DefaultScreen(s->d)), my_x,0,my_x,256);
	if (!(my_x%(16*4)))
	{
		gcv.foreground=s->col[DARKGREY];
		XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground | GCLineWidth, &gcv);
	}
  }
 
  /* draw the vertical lines (again, every fourth line is coloured white) */
  while (my_y<256)
  {
    my_y += 16;
    if (!(my_y%(16*4)))
    {
	gcv.foreground=s->col[WHITE];
	XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground | GCLineWidth, &gcv);
    }
    XDrawLine(s->d, s->pw, DefaultGC(s->d, DefaultScreen(s->d)), 0, my_y, 1024, my_y);
    if (!(my_y%(16*4)))
    {
	gcv.foreground=s->col[DARKGREY];
	XChangeGC(s->d, DefaultGC(s->d, DefaultScreen(s->d)), GCForeground | GCLineWidth, &gcv);
    }
  }

  /* end of our code (Christian Klein) */

  XFlush(s->d);
}

/* return 0 if pb 1 otherwise */
int init_screen(SCREEN *s, WAVE *a, WAVE *o)
{
  XKeyboardControl kk;
  XEvent ev;
  XColor col1[5], col2[5];
  s->a=a;
  s->o=o;
  s->mx=s->my=0;	/* we'll get it when it will move or press (we can't have release if no press first) */
  s->mode=DEFAULT;
  s->t1[0]=s->t2[0]=0;
  s->black_message="Sound closed";
  strcpy(s->not,"4");
  strcpy(s->cft,"440");
  s->no=4;
  s->cf=440;
  s->dwt[0]=0;
  s->dwb=UP;

  /* let's create our X stuff */
  /* first, open the display */
  if (!(s->d = XOpenDisplay(0))) {
    fprintf(stderr, "XOpenDisplay error\n");
    return 0;
  }

  /* we use XBell, let's change the bell duration to a small value */
  kk.bell_duration=50;
  XChangeKeyboardControl(s->d, KBBellDuration, &kk);

  /* now, allocate some colors */
  if (  !XAllocNamedColor(s->d, DefaultColormap(s->d, DefaultScreen(s->d)), "black",     &col1[0], &col2[0])
     || !XAllocNamedColor(s->d, DefaultColormap(s->d, DefaultScreen(s->d)), "white",     &col1[1], &col2[1])
     || !XAllocNamedColor(s->d, DefaultColormap(s->d, DefaultScreen(s->d)), "grey",      &col1[2], &col2[2])
     || !XAllocNamedColor(s->d, DefaultColormap(s->d, DefaultScreen(s->d)), "lightgrey", &col1[3], &col2[3])
     || !XAllocNamedColor(s->d, DefaultColormap(s->d, DefaultScreen(s->d)), "darkgrey",  &col1[4], &col2[4])
     ) {
    fprintf(stderr, "XAllocColor error\n");
    return 0;
  }
  s->col[BLACK]		= col1[0].pixel;
  s->col[WHITE]		= col1[1].pixel;
  s->col[GREY]		= col1[2].pixel;
  s->col[LIGHTGREY]	= col1[3].pixel;
  s->col[DARKGREY]	= col1[4].pixel;

  /* then create the main window */
  s->mw = XCreateSimpleWindow(s->d, DefaultRootWindow(s->d), 0, 0, 1024, 256*3+100, 0, 0, s->col[GREY]);

  /* register some events for it */
  XSelectInput(s->d, s->mw, KeyPressMask | ButtonPressMask | ButtonReleaseMask | PointerMotionMask | ExposureMask);

  /* create the wave windows and the play one and the text ones */
  s->wf1 = XCreateSimpleWindow(s->d, s->mw, 10, 16*3, 512, 256, 0, 0, s->col[LIGHTGREY]);
  s->wf2 = XCreateSimpleWindow(s->d, s->mw, 10, 16*3+256+16, 512, 256, 0, 0, s->col[LIGHTGREY]);
  s->pw  = XCreateSimpleWindow(s->d, s->mw, 0, 16*3+256+16+256+16, 1024, 256, 0, 0, s->col[BLACK]);

  s->tw1 = XCreateSimpleWindow(s->d, s->mw, 10+512+20, 100+4, 78*6, 16, 0, 0, s->col[WHITE]);
  s->tw2 = XCreateSimpleWindow(s->d, s->mw, 10+512+20, 100+4+256+16, 78*6, 16, 0, 0, s->col[WHITE]);
  s->cfw = XCreateSimpleWindow(s->d, s->mw, 750+200, 256+16*3+256-20, 11*6, 16, 0, 0, s->col[WHITE]);
  s->now = XCreateSimpleWindow(s->d, s->mw, 750+200, 256+16*3+256, 11*6, 16, 0, 0, s->col[WHITE]);
  s->dww = XCreateSimpleWindow(s->d, s->mw, 750+100, 40, 20*6, 16, 0, 0, s->col[WHITE]);
  /* and map them */
  XMapWindow(s->d, s->wf1);
  XMapWindow(s->d, s->wf2);
  XMapWindow(s->d, s->pw);
  XMapWindow(s->d, s->tw1);
  XMapWindow(s->d, s->tw2);
  XMapWindow(s->d, s->cfw);
  XMapWindow(s->d, s->now);
  XMapWindow(s->d, s->dww);

  /* for the sound open/close stuff, we need to receive leave/enter notifying messages for the play window */
  XSelectInput(s->d, s->pw, LeaveWindowMask | EnterWindowMask);

  /* now, map the main window (the real way, ie we wait for it to be mapped) */
  XMapWindow(s->d, s->mw);
  do
    XNextEvent(s->d, &ev);
  while (ev.type != Expose && ev.xexpose.window != s->mw);

  /* the buttons go to their place */
  /* 0 = quit */
  s->buttons[0][0]=10+512+20+40-20+50;  s->buttons[0][1]=50-20;
  s->buttons[0][2]=10+512+20+40-20+20*2+4*6+50;  s->buttons[0][3]=50-20+20*2-10;

  /* 1 = top load */
  s->buttons[1][0]=10+512+20+40-20;  s->buttons[1][1]=150-20;
  s->buttons[1][2]=10+512+20+40-20+20*2+4*6;  s->buttons[1][3]=150-20+20*2-10;

  /* 2 = top save */
  s->buttons[2][0]=10+512+20+40-20+100;  s->buttons[2][1]=150-20;
  s->buttons[2][2]=10+512+20+40-20+20*2+4*6+100;  s->buttons[2][3]=150-20+20*2-10;

  /* 3 = top reset */
  s->buttons[3][0]=10+512+20+40-20+100+100;  s->buttons[3][1]=150-20;
  s->buttons[3][2]=10+512+20+40-20+20*2+4*6+100+100;  s->buttons[3][3]=150-20+20*2-10;

  /* 4 = down load */
  s->buttons[4][0]=10+512+20+40-20;  s->buttons[4][1]=150-20+256+16;
  s->buttons[4][2]=10+512+20+40-20+20*2+4*6;  s->buttons[4][3]=150-20+20*2-10+256+16;

  /* 5 = down save */
  s->buttons[5][0]=10+512+20+40-20+100;  s->buttons[5][1]=150-20+256+16;
  s->buttons[5][2]=10+512+20+40-20+20*2+4*6+100;  s->buttons[5][3]=150-20+20*2-10+256+16;

  /* 6 = down reset */
  s->buttons[6][0]=10+512+20+40-20+100+100;  s->buttons[6][1]=150-20+256+16;
  s->buttons[6][2]=10+512+20+40-20+20*2+4*6+100+100;  s->buttons[6][3]=150-20+20*2-10+256+16;

  /* now, draw it */
  draw_screen(s);

  /* the mouse aspect */
  s->curs[DEFAULT_ZONE]=XCreateFontCursor(s->d, XC_top_left_arrow);
  s->curs[WAVE_ZONE]=XCreateFontCursor(s->d, XC_target);
  s->curs[POINT_SELECTED]=XCreateFontCursor(s->d, XC_plus);
  s->curs[PLAY_ZONE_OFF]=XCreateFontCursor(s->d, XC_tcross);
  s->curs[PLAY_ZONE_ON]=XCreateFontCursor(s->d, XC_plus);
  s->curs[BUTTON_ZONE]=XCreateFontCursor(s->d, XC_hand2);
  s->curs[TEXT_ZONE]=XCreateFontCursor(s->d, XC_xterm);
  mouse_aspect(s, DEFAULT_ZONE);

  /* ok, done */
  return 1;
}

int get_screen_descriptor(SCREEN *s)
{
  return ConnectionNumber(s->d);
}

int is_mouse_in_play_window(SCREEN *s)
{
  return s->mode==PLAY_MODE;
}

/* return -1 if the user leaves the program 0 if not */
int handle_key(SCREEN *s, XKeyEvent *ev)
{
  char *t;
  Window w;
  int l, max;

  char dum[50];
  KeySym ks;

  if (s->mode != DEFAULT)
    return 0;

  XLookupString(ev, dum, 50, &ks, (XComposeStatus *)0);
  if (ks==XK_Escape) {
    /* we may be dumping. If so, close the dump */
    if (s->dwb==DOWN)
      close_dump_wav();
    return -1;
  }

  if (ev->subwindow!=s->tw1 && ev->subwindow!=s->tw2 &&
      ev->subwindow!=s->cfw && ev->subwindow!=s->now &&
      ev->subwindow!=s->dww)
    return 0;

  if (ev->subwindow==s->tw1) {
    w=s->tw1;
    t=s->t1;
    max=77;
  } else if (ev->subwindow==s->tw2) {
    w=s->tw2;
    t=s->t2;
    max=77;
  } else if (ev->subwindow==s->now) {
    w=s->now;
    t=s->not;
    max=10;
  } else if (ev->subwindow==s->cfw) {
    w=s->cfw;
    t=s->cft;
    max=10;
  } else { /* s->dww */
    w=s->dww;
    t=s->dwt;
    max=19;
  }

  l=strlen(t);

  /* in text area, let's deal the keys */
  if (ks>=0x20 && ks <=0xff) {
    if (l>=max)
      return 0;
    t[l]=ks;
    t[l+1]=0;
    draw_text(s, w, t);
  }
  if (ks==XK_BackSpace || ks==XK_Delete) {
    if (l==0)
      return 0;
    t[l-1]=0;
    draw_text(s, w, t);
  }

  return 0;
}

/* return 1 if point added ok, 0 if not (this function should not be in this file !) */
int add_point(SCREEN *s, WAVE *w)
{
  int i;
  int *nwx;
  int *nwy;

  /* watch this crazy code ! (bubble sort-like) */
  /* get new mem */
  nwx=(int *)realloc(w->control_points_x, (w->nb_control_points+1)*sizeof(int));
  if (!nwx)
    return 0;
  nwy=(int *)realloc(w->control_points_y, (w->nb_control_points+1)*sizeof(int));
  if (!nwy)
    return 0;

  w->control_points_x=nwx;
  w->control_points_y=nwy;
  i=w->nb_control_points++;

  /* copy the new point to the end of the stuff and let it go back up (bubble sort rules !) */
  w->control_points_x[i]=s->mx;
  w->control_points_y[i]=(128-s->my)*256;
  for (;i>0;i--) {
    int x, y;
    if (w->control_points_x[i-1]<w->control_points_x[i])
      break;
    x=w->control_points_x[i-1];
    y=w->control_points_y[i-1];
    w->control_points_x[i-1]=w->control_points_x[i];
    w->control_points_y[i-1]=w->control_points_y[i];
    w->control_points_x[i]=x;
    w->control_points_y[i]=y;
  }

  draw_wave(s, (Window)s->mode5, w);

  return 1;
}

/* return 1 if a point was deleted 0 if not */
int delete_point(SCREEN *s, WAVE *w, int p)
{
  int i;
  int *nwx;
  int *nwy;

  if (p==-1)
    return 0;

  if (p==0)
    return 0;

  if (w->nb_control_points==2)
    return 0;

  for (i=p;i<w->nb_control_points-1;i++) {
    w->control_points_x[i]=w->control_points_x[i+1];
    w->control_points_y[i]=w->control_points_y[i+1];
  }

  nwx=(int *)realloc(w->control_points_x, (w->nb_control_points-1)*sizeof(int));
  if (!nwx) {
    fprintf(stderr, "screen.delete_point Memory corruption - big alert ! Stop the program NOW ! data loss for sure !\n");
    return 0;
  }
  nwy=(int *)realloc(w->control_points_y, (w->nb_control_points-1)*sizeof(int));
  if (!nwy) {
    fprintf(stderr, "screen.delete_point Memory corruption - big alert ! Stop the program NOW ! data loss for sure !\n");
    return 0;
  }

  w->control_points_x=nwx;
  w->control_points_y=nwy;
  w->nb_control_points--;

  draw_wave(s, (Window)s->mode5, w);

  return 1;
}

/* return the point where the mouse is (return -1 if no point found) */
int get_moved_point(SCREEN *s, WAVE *w)
{
  int i;

  for (i=0; i<w->nb_control_points; i++)
    if (abs(s->mx-w->control_points_x[i])<=2 && abs(s->my-(128-w->control_points_y[i]/256))<=2)
      return i;

  return -1;
}

/* return 1 if the mouse is on a point, 0 if not */
int is_in_a_point(SCREEN *s, WAVE *w)
{
  int i;

  /* only in x test - we might have trouble with add_point otherwise */
  for (i=0; i<w->nb_control_points; i++)
    if (abs(s->mx-w->control_points_x[i])<=2)
      return 1;

  return 0;
}

void handle_button_press(SCREEN *s, XButtonPressedEvent *ev)
{
  int b;

  s->mx=ev->x;
  s->my=ev->y;

  /* maybe in message mode */
  if (s->mode == MESSAGE_MODE) {
    if (ev->button!=Button1 || !is_in_message_button(s))
      return;

    s->mode7=(void *)1;
    s->mode6=(void *)DOWN;
    draw_message_button(s);
    return;
  }

  /* if in other mode than default, we have a pushed button somewhere, so fuck off ! */
  if (s->mode!=DEFAULT) {
    XBell(s->d, 100);
    return;
  }

  /* if in a button, push the button */
  if ((b=is_in_a_button(s))) {
    if (ev->button != Button1)
      return;

    b--;
    draw_button(s, b, DOWN);
    s->mode=BUTTON_MODE;
    s->mode1=(void *)b;
    return;
  }

  /* if in a wave form window, check if on an alrealy existing point or create one if not */
  if (ev->subwindow == s->wf1 || ev->subwindow == s->wf2) {
    WAVE *w;
    int dx, dy;

    if (ev->subwindow == s->wf1) {
      s->mx-=dx=10;
      s->my-=dy=16*3;
      w=s->a;
    } else {
      s->mx-=dx=10;
      s->my-=dy=16*3+256+16;
      w=s->o;
    }

    /* if button 1 create or select */
    if (ev->button == Button1) {
      s->mode5=(void *)ev->subwindow;
      /* let mx and my be relative to the wf1 subwindow */
      if (!is_in_a_point(s, w))
	if (!add_point(s, w))
	  return;
      if ((s->mode2=(void *)get_moved_point(s, w))==(void *)-1)
	return;
      s->mode=WAVE_MOVE;
      s->mode1=w;
      s->mode3=(void *)dx;
      s->mode4=(void *)dy;
      mouse_aspect(s, POINT_SELECTED);
      return;
    }
    /* if button 3 delete */
    if (ev->button == Button3) {
      if (!is_in_a_point(s, w))
	return;
      s->mode5=(void *)ev->subwindow;
      if (delete_point(s, w, get_moved_point(s, w)))
	mouse_aspect(s, WAVE_ZONE);
      return;
    }
    return;
  }

  /* if in playable area, let's enter play mode and start the playing */
  if (ev->subwindow == s->pw) {
    if (ev->button != Button1)
      return;

    s->mode1=(void *)0;
    s->mode2=(void *)(16*3+256+16+256+16);
    s->mx-=0;
    s->my-=16*3+256+16+256+16;
    s->mode3=(void *)s->mx;
    s->mode4=(void *)s->my;
    if (enter_playmode(s)) {
      mouse_aspect(s, PLAY_ZONE_ON);
      s->mode=PLAY_MODE;
    } else
      fprintf(stderr, "Impossible to play, error with initing the sound (or grabing the pointer)\n");
  }

  /* if dump to wav button, toggle it */
  if (is_in_dump_wav_button(s)) {
    if (s->dwb==UP)
      s->dwb=DOWN;
    else
      s->dwb=UP;
    draw_dump_button(s);
  }
}

void default_mouse_aspect(SCREEN *s, Window subwin)
{
  if (subwin==s->wf1 || subwin==s->wf2) {
    WAVE *w;
    int dx, dy;

    if (subwin == s->wf1) {
      s->mx-=dx=10;
      s->my-=dy=16*3;
      w=s->a;
    } else {
      s->mx-=dx=10;
      s->my-=dy=16*3+256+16;
      w=s->o;
    }
    if (get_moved_point(s, w)==-1)
      mouse_aspect(s, WAVE_ZONE);
    else
      mouse_aspect(s, POINT_SELECTED);
  }
  else if (subwin==s->pw)
    mouse_aspect(s, PLAY_ZONE_OFF);
  else if (is_in_a_button(s))
    mouse_aspect(s, BUTTON_ZONE);
  else if (subwin==s->tw1 || subwin==s->tw2 || subwin==s->cfw || subwin==s->now || subwin==s->dww)
    mouse_aspect(s, TEXT_ZONE);
  else if (is_in_dump_wav_button(s))
    mouse_aspect(s, BUTTON_ZONE);
  else
    mouse_aspect(s, DEFAULT_ZONE);
}

/* return -1 if the user leaves the program 0 if not */
int handle_button_release(SCREEN *s, XButtonReleasedEvent *ev)
{
  s->mx=ev->x;
  s->my=ev->y;

  switch (s->mode) {
    case WAVE_MOVE : {
      /* if not button 1, ignore the event */
      if (ev->button != Button1)
	break;
      s->mode=DEFAULT;
      default_mouse_aspect(s, ev->subwindow);
      break;
    }

    case PLAY_MODE : {
      if (ev->button != Button1)
	break;
      s->mode=DEFAULT;
      leave_playmode(s);
      mouse_aspect(s, PLAY_ZONE_OFF);
      break;
    }

    case BUTTON_MODE : {
      s->mode=DEFAULT;
      default_mouse_aspect(s, 0);
      draw_button(s, (int)s->mode1, UP);
      if (!is_in_the_button(s, (int)s->mode1))
	break;
      return button_action(s, (int)s->mode1);
    }

    case MESSAGE_MODE : {
      if (ev->button != Button1)
	break;

      if (!is_in_message_button(s)) {
	s->mode7=(void *)0;
	mouse_aspect(s, DEFAULT);
	break;
      }
      clear_message(s);
      s->mode=DEFAULT;
      break;
    }

  }

  return 0;
}

void handle_pointer_motion(SCREEN *s, XMotionEvent *ev)
{
  s->mx=ev->x;
  s->my=ev->y;

  switch (s->mode) {
    case WAVE_MOVE : {
      int maxx, minx;
      WAVE *w=(WAVE *)s->mode1;
      Window win=(Window)s->mode5;
      int p=(int)s->mode2;
      /* let's put the mouse relative the to good wf window */
      s->mx-=(int)s->mode3;
      s->my-=(int)s->mode4;
      /* now put the point to its new place */
      w->control_points_x[p]=s->mx;
      w->control_points_y[p]=(128-s->my)*256;
      /* check the rightness of the values */
      maxx=512;
      minx=w->control_points_x[p-1];
      if (p==0)
	w->control_points_x[p]=0;
      if (p!=w->nb_control_points-1)
	maxx=w->control_points_x[p+1];
      if (p!=0) {
	if (w->control_points_x[p]<=minx)
	  w->control_points_x[p]=minx+1;
	if (w->control_points_x[p]>=maxx)
	  w->control_points_x[p]=maxx-1;
      }
      if (w->control_points_y[p]<-32768)
	w->control_points_y[p]=-32768;
      if (w->control_points_y[p]>32767)
	w->control_points_y[p]=32767;
      draw_wave(s, win, w);
      print_mouse_coordinates(s);
      break;
    }
    case PLAY_MODE : {
      s->mx-=(int)s->mode1;
      s->my-=(int)s->mode2;
      print_mouse_coordinates(s);
      break;
    }
    case BUTTON_MODE : {
      if (is_in_the_button(s, (int)s->mode1))
	draw_button(s, (int)s->mode1, DOWN);
      else
	draw_button(s, (int)s->mode1, UP);
      break;
    }
    case MESSAGE_MODE : {
      /* ugly code, sorry */
      if (is_in_message_button(s)) {
	mouse_aspect(s, BUTTON_ZONE);
	if ((int)s->mode7) {
	  s->mode6=(void *)DOWN;
	  draw_message_button(s);
	}
      } else {
	if (!(int)s->mode7)
	  mouse_aspect(s, DEFAULT_ZONE);
	else {
	  s->mode6=(void *)UP;
	  draw_message_button(s);
	}
      }
      break;
    }
    default : {
      /* barabarian - should handle all this stuff much better, nope ? */
      if (ev->subwindow == s->wf1) {
	s->mx-=10;
	s->my-=16*3;
	print_mouse_coordinates(s);
	s->mx+=10;
	s->my+=16*3;
      } else if (ev->subwindow == s->wf2) {
	s->mx-=10;
	s->my-=16*3+256+16;
	print_mouse_coordinates(s);
	s->mx+=10;
	s->my+=16*3+256+16;
      } else if (ev->subwindow == s->pw) {
	s->mx-=0;
	s->my-=16*3+256+16+256+16;
	print_mouse_coordinates(s);
	s->mx+=0;
	s->my+=16*3+256+16+256+16;
      } else
	clear_mouse_coordinates(s);
      default_mouse_aspect(s, ev->subwindow);
    }
  }
}

/* return -1 if the user leaves the program 0 if not */
int handle_screen_event(SCREEN *s)
{
  int type=0;
  XEvent ev, oev;

  while(XCheckMaskEvent(s->d, -1L, &ev)!=False)
    switch(ev.type) {
      case Expose :
	type |= EXPOSE;
	break;
      case KeyPress :
	if (handle_key(s, (XKeyEvent *)&ev)==-1)
	  return -1;
	break;
      case ButtonPress :
	handle_button_press(s, (XButtonPressedEvent *)&ev);
	break;
      case ButtonRelease :
	if (handle_button_release(s, (XButtonReleasedEvent *)&ev)==-1)
	  return -1;
	break;
      case MotionNotify :
	type |= MOTION;
	oev=ev;
	break;
      case EnterNotify :
	if (s->mode == MESSAGE_MODE)
	  break;
	if (init_sound(44100, 16, 0)) {
	  double a;
	  char *e;
	  s->black_message="Sound open";
	  /* let's check central frequency and number of octave values */
	  a=strtod(s->not, &e);
	  if (!strlen(s->not) || *e || a<0.0001 || a>1000.) {
	    strcpy(s->not, "4");
	    s->no=4;
	    draw_text(s, s->now, s->not);
	  } else
	    s->no=a;
	  a=strtod(s->cft, &e);
	  if (!strlen(s->cft) || *e || a<1. || a>30000.) {
	    strcpy(s->cft, "440");
	    s->cf=440;
	    draw_text(s, s->cfw, s->cft);
	  } else
	    s->cf=a;
	  /* let's see if we have to dump to wav */
	  if (s->dwb==DOWN)
	    if (!init_dump_wav(s->dwt)) {
	      s->dwb=UP;
	      draw_dump_button(s);
	    }
	} else
	  s->black_message="Sound ERROR !";
	black_message(s);
	break;
      case LeaveNotify :
	if (s->mode == PLAY_MODE || s->mode == MESSAGE_MODE)
	  break;
	if (s->dwb==DOWN)
	  if (!close_dump_wav()) {
	    s->dwb=UP;
	    draw_dump_button(s);
	  }
	close_sound();
	s->black_message="Sound closed";
	black_message(s);
	break;
    }

  if (type & EXPOSE)
    draw_screen(s);

  if (type & MOTION)
    handle_pointer_motion(s, (XMotionEvent *)&oev);

  return 0;
}

int get_mouse_x(SCREEN *s)
{
  return s->mx;
}

int get_mouse_y(SCREEN *s)
{
  return s->my;
}

void close_screen(SCREEN *s)
{
  XKeyboardControl kk;

  /* set back bell duration */
  kk.bell_duration=-1;
  XChangeKeyboardControl(s->d, KBBellDuration, &kk);
  XFlush(s->d);
}
