/*
 * the oa project.
 *
 * Sed - december 1999
 *
 * This is public domain.
 *
 * the screen header file
 */

#ifndef _SCREEN_H_
#define _SCREEN_H_

#include <X11/Xlib.h>

#include "waves.h"

#define BLACK		0
#define WHITE		1
#define GREY		2
#define LIGHTGREY	3
#define DARKGREY	4

/* interface modes */
#define	DEFAULT		0
#define	WAVE_MOVE	1
#define PLAY_MODE	2
#define	BUTTON_MODE	3
#define MESSAGE_MODE	4

/* mouse aspect */
#define	DEFAULT_ZONE	0
#define	WAVE_ZONE	1
#define	POINT_SELECTED	2
#define	PLAY_ZONE_OFF	3
#define	PLAY_ZONE_ON	4
#define	BUTTON_ZONE	5
#define TEXT_ZONE	6

typedef struct {
  Display *d;
  Cursor curs[7];		/* the cursors */
  int buttons[7][4];		/* the buttons coordinates - x left, y left, x right, y right */
  Window mw;			/* the main window */
  Window pw;			/* the play window */
  Window wf1, wf2;		/* the wave form windows */
  Window tw1, tw2;		/* the text area windows */
  Window cfw, now;		/* central frequency choice window and number of octave choice window */
  Window dww;			/* dump to wave file name window */
  char t1[78];			/* file name 1 */
  char t2[78];			/* file name 2 */
  char not[11], cft[11];	/* nb octaves text, central frequency text */
  char dwt[20];			/* dump to wav file name */
  int dwb;			/* dump to wav button - UP or DOWN */
  int col[5];			/* the colors indexes */
  char *black_message;		/* a message shown - sound open/close/error */
  WAVE *a, *o;			/* pointers to the two WAVE - we show them so we need them, huh ? */
  double no, cf;		/* nb of octaves, central frequency */
  int mx, my;			/* mouse position */
  int mode;			/* the current mode of the interface */
  void *mode1;			/* current mode data 1 */
  void *mode2;			/* current mode data 2 */
  void *mode3;			/* current mode data 3 */
  void *mode4;			/* current mode data 4 */
  void *mode5;			/* current mode data 5 */
  void *mode6;			/* current mode data 6 */
  void *mode7;			/* current mode data 7 */
} SCREEN;

/* screen event definitions (1, 2, 4, 8, ...) because we or them */
#define	EXPOSE		1
#define MOTION		2

#define	UP	0
#define	DOWN	1

int init_screen(SCREEN *, WAVE *, WAVE *);
int get_screen_descriptor(SCREEN *);
int is_mouse_in_play_window(SCREEN *);
int handle_screen_event(SCREEN *);
void close_screen(SCREEN *);
int get_mouse_x(SCREEN *);
int get_mouse_y(SCREEN *);

void draw_wave(SCREEN *s, Window win, WAVE *w);

#endif /* _SCREEN_H_ */
